package Pytanie11_5;

public class Pytanie {
	public static int searchI(String[] strings, String str, int first, int last) {
		while (first <= last) {
			/* Ustawianie elementu mid na środek */
			int mid = (last + first) / 2;
			
			/* Jeśli element mid jest pusty, należy znaleźć najbliższy niepusty łańcuch */
			if (strings[mid].isEmpty()) { 
				int left = mid - 1;
				int right = mid + 1;
				while (true) {
					if (left < first && right > last) {
						return -1;
					} else if (right <= last && !strings[right].isEmpty()) {
						mid = right;
						break;
					} else if (left >= first && !strings[left].isEmpty()) {
						mid = left;
						break;
					}
					right++;
					left--;
				}
			}
			
			int res = strings[mid].compareTo(str);
			if (res == 0) { // Znaleziono element
				return mid;
			} else if (res < 0) { // Przeszukiwanie prawej strony
				first = mid + 1;
			} else { // Przeszukiwanie lewej strony
				last = mid - 1;
			}
		}
		return -1;
	}	
	
	public static int searchR(String[] strings, String str, int first, int last) {
		if (first > last) {
			return -1;
		}
		
		/* Ustawianie mid na środek */
		int mid = (last + first) / 2;
		
		/* Jeśli element mid jest pusty, należy znaleźć najbliższy niepusty łańcuch */
		if (strings[mid].isEmpty()) { 
			int left = mid - 1;
			int right = mid + 1;
			while (true) {
				if (left < first && right > last) {
					return -1;
				} else if (right <= last && !strings[right].isEmpty()) {
					mid = right;
					break;
				} else if (left >= first && !strings[left].isEmpty()) {
					mid = left;
					break;
				}
				right++;
				left--;
			}
		}
			
		/* Sprawdzanie łańcucha i w razie potrzeby wywołanie rekurencyjne */
		if (str.equals(strings[mid])) { // Znaleziono element
			return mid;
		} else if (strings[mid].compareTo(str) < 0) { // Przeszukiwanie prawej strony
			return searchR(strings, str, mid + 1, last);
		} else { // Przeszukiwanie lewej strony
			return searchR(strings, str, first, mid - 1);
		}
	}	
		
	public static int search(String[] strings, String str) {
		if (strings == null || str == null || str.isEmpty()) {
			return -1;
		}
		return searchR(strings, str, 0, strings.length - 1);
	}
	
	public static void main(String[] args) {
        String[] stringList = {"ananas", "", "", "banan", "", "", "", "cukinia", "dynia", "", "", "ekierka", "", "fikus"};
        System.out.println(search(stringList, "ac"));
        
		//for (String s : stringList) {
		//	String cloned = new String(s);
        //	System.out.println("<" + cloned + "> " + " występuje na pozycji " + search(stringList, cloned));
		//}
	}
}
